(define (domain coarse-worker)

(:requirements :adl :equality :fluents)

(:types	object
		position
		goalobj - object
		worker - object
)

(:predicates 
		(at ?object - object ?pos - position)
		(atgoal ?worker - worker)
)

(:functions
		(positionCost ?pos - position)
		(posX ?pos - position)
		(posY ?pos - position)
		(total-cost)
)

(:action END
		:parameters (?goalobj - goalobj ?worker - worker ?position - position)
		:precondition  (and
				(at ?worker ?position)
				(at ?goalobj ?position)
		)
		:effect	(and
				(atgoal ?worker)
				(not (at ?worker ?position))
		)
)

(:action MOVE
		:parameters (?worker - worker ?dest - position ?source - position)
		:precondition  (at ?worker ?source)
		:effect	(and
				(not (at ?worker ?source))
				(at ?worker ?dest)
				(when (< (posX ?source) (posX ?dest)) (increase (total-cost) (- (posX ?dest) (posX ?source))))
				(when (> (posX ?source) (posX ?dest)) (increase (total-cost) (- (posX ?source) (posX ?dest))))
				(when (< (posY ?source) (posY ?dest)) (increase (total-cost) (- (posY ?dest) (posY ?source))))
				(when (> (posY ?source) (posY ?dest)) (increase (total-cost) (- (posY ?source) (posY ?dest))))
				(when (< (positionCost ?source) (positionCost ?dest)) (increase (total-cost) (- (positionCost ?dest) (positionCost ?source))))
		)
)

)
