#ifndef EMITTER_H
#define EMITTER_H

#include"linalg.h"

struct Particle
{
  vec3 pos;
  vec3 vel;
  vec3 acc;
  float alpha;
  float fric;
  
  void update(float dt,float da)
  {
    pos=pos+vel*dt;
    vel=vel+acc*dt+vel*fric*dt;
    alpha+=da;
  }
};

class Emitter
{
  public:
    Emitter(int c,float r,float tl,vec3 p,vec3 pr,vec3 v,vec3 vr,vec3 ac,float f,float fr,float da,float ww,float hh,GLuint texid,GLuint colid);
    ~Emitter(){delete list;};
    void update(float dt);
    void draw();
  protected:
    void newparticle();

    float rate;
    float limit;
    
    vec3 pos;
    vec3 p_rand;
    vec3 vel;
    vec3 v_rand;
    vec3 acc;
    float fric;
    float f_rand;
    float dalpha;

    Particle *list;
    int first;
    int last;
    int count;

    float w;
    float h;
    int billboard_tex;
    int color_tex;
};

#endif
