#include"GLee.h"
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<stdio.h>
#include<GL/gl.h>
#include<GL/glut.h>
#include"benchcam.h"
#include"glutil.h"
#include"linalg.h"
#include"emitter.h"
#include"fps.h"
#include<math.h>

benchcam cam(benchcam::RECORD,0,1,4);
int wwidth=800,wheight=600;
int current=0;
int interp=0;
Emitter *emitter;
FPS fps(50);

unsigned char keydown[256];

void display()
{
  glClearColor(0.2,0.3,0.4,0);
  glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT);

  
  glMatrixMode(GL_MODELVIEW);

  glPushMatrix();
  glLoadIdentity();
  

  cam.update();
  cam.apply_transform();

  static float frame=0;
  frame+=0.1;

  glColor3f(1,1,1);

//  glEnable(GL_TEXTURE_2D);

  glColor3f(0,0,0);
  glBegin(GL_QUADS);
  glVertex3f(1,0,-1);
  glVertex3f(1,0,1);
  glVertex3f(-1,0,1);
  glVertex3f(-1,0,-1);
  glEnd();


  fps.update();

  emitter->update(fps.getDt());
  emitter->draw();


  glutSwapBuffers();

  static int framecount=0;
  framecount++;
  if(framecount%100==0)printf("%f fps\n",fps.getFPS());

//  printerror("display");
}

void mouse(int x,int y)
{
  cam.update_mouse_moved(x,y);
}

void clicks(int button,int state,int x,int y)
{
  cam.update_mouse_pressed(button,state,x,y);
}

void keyup(unsigned char key, int x, int y)
{
    keydown[key] = 0;
}

void keys(unsigned char key,int x,int y)
{
  static int count=0;
  static int fill;
  
  keydown[key] = 1;
  
  switch(key)
  {
    case 27: exit(0);
    case ' ': current=(current+1)%6;break;
    case 'f': fill=!fill;
	      if(fill)glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	      else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	      break;
    case '1':
	      delete emitter;
    emitter=new Emitter(100,20,100000,vec3(0,1,0),vec3(0.01,0,0.01),vec3(0,0.5,0),vec3(0.1,0.1,0.1),vec3(0,0.5,0),0,0,-1,0.1,0.1,loadtga("dot.tga"),loadtga1D("flame_color.tga"));
    break;
    case '2':
	      delete emitter;
    emitter=new Emitter(100,1000,0.1,vec3(0,1,0),vec3(0.01,0,0.01),vec3(0,0,0),vec3(2,2,2),vec3(0,2,0),-5,3,-1,0.1,0.1,loadtga("dot.tga"),loadtga1D("flame_color.tga"));
    break;
    case '3':
	      delete emitter;
    emitter=new Emitter(1000,100,100000,vec3(0,1,0),vec3(0.01,0,0.01),vec3(0,2,0),vec3(1,0.1,1),vec3(0,-3,0),0,0,-0.7,0.05,0.05,loadtga("dot.tga"),loadtga1D("flare_color.tga"));
    break;
    case '4':
	      delete emitter;
    emitter=new Emitter(100,1000,0.1,vec3(0,1,0),vec3(0.01,0,0.01),vec3(0,0,0),vec3(2,2,2),vec3(0,2,0),0,0,-5,0.1,0.1,loadtga("dot.tga"),loadtga1D("flame_color.tga"));
    break;

  }
  glutPostRedisplay();
}

void postRedisplay()
{
  glutPostRedisplay();
}

void reshape(int w,int h)
{
  wwidth=w;
  wheight=h;
  glViewport(0,0,w,h);
}

int main(int ac,char **av)
{
  char *emptytex;
  int i,j;

  glutInit(&ac, av);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
  glutInitWindowSize(wwidth,wheight);
  glutCreateWindow("demo");
  glutDisplayFunc(display);
  glutIdleFunc(display);
  glutMotionFunc(mouse);
  glutPassiveMotionFunc(mouse);
  glutMouseFunc(clicks);

  memset(keydown,0,256);
  glutKeyboardFunc(keys);
  glutKeyboardUpFunc(keyup);
  glutReshapeFunc(reshape);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  glCullFace(GL_BACK);
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glMatrixMode(GL_PROJECTION);
  gluPerspective(40,4.0/3.0,1,10000);
  glMatrixMode(GL_MODELVIEW);
  
  GLeeInit();

  glEnable(GL_TEXTURE_2D);
  glFrontFace(GL_CW);
  glEnable(GL_COLOR_MATERIAL);


  keys('1',0,0);

  cam.set_speed(0.1);
  cam.set_keyboard_array(keydown);

  glutMainLoop();
  return 0;
}
