
#include "Global.H"
#include "GameStateModule.H"
#include "Game.H"
#include "GameObj.H"
#include "BuildTasksState.h"

namespace BSimul{
  
  

  GameObj* BuildTasksState::getNearestEnemyControlCenter(const ObjectVector& objects){
    
    sint4 x,y;
    real8 nearest = 1e30;
    TerrainBase::Loc centroid = getCenterOfObjects(objects);
    TerrainBase::Loc nearestBase, basePosition;
    GameObj* base = NULL;

    FORALL(enemyBases,it) {
      (*it)->get_center(x,y);
      basePosition=TerrainBase::Loc(x,y);
      real8 dist = (basePosition).distance(centroid);
	if(dist < nearest) {
	  nearestBase = basePosition;
	  nearest = dist;
	  base = (*it);
	}
    }
    return base;
  }
  
  


  TerrainBase::Loc BuildTasksState::getCenterOfObjects(const ObjectVector& objects){

    sint4 x, y;
    sint4 sumx=0;
    sint4 sumy=0;
    FORALL(objects, it){
      (*it)->get_center(x,y);
      sumx+=x;
      sumy+=y;
    }

    return TerrainBase::Loc(sumx/objects.size(), sumy/objects.size());
  }

  GameObj* BuildTasksState::getNearestEnemyWorker(const ObjectVector& objects){
    sint4 x,y;
    TerrainBase::Loc centroid=getCenterOfObjects(objects);
    TerrainBase::Loc workerPosition;
    GameObj* nearestWorker;
    real8 dist, nearest;
    nearest=1e30;
    FORALL(enemyWorkers, it){
      (*it)->get_center(x,y);
      workerPosition=TerrainBase::Loc(x,y);
      dist=centroid.distance(workerPosition);
      if(dist < nearest){
	nearestWorker=(*it);
	nearest=dist;
      }
    }
    return nearestWorker;
  }

  bool BuildTasksState::noEnemyInRange(const GameObj* obj){
    FORALL(enemyFighters, it){
      if((*it)->distance_to(*obj)<=(4*16))
	return false;
    }
    return true;
  }
  
  GameObj* BuildTasksState::enemyNearBases(){
    real8 dist;
    FORALL(friendlyBases, it){
      FORALL(enemyFighters, it2){
	dist=it->first->distance_to(*(*it2));
	if(dist<128)
	  return (*it2);
      }
    }
    return NULL;
  }

}
  
