// $Id: CGridBase.C,v 1.1 2006/06/27 02:32:29 orts_mburo Exp $
 
// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "CGridBase.H"
#include "GfxGlobal.H"
#include "Game.H"

using namespace std;

//===================================================================

CGridBase::CGridBase()
{
}

//-------------------------------------------------------------------

CGridBase::~CGridBase() {}

//===================================================================

void CGridBase::draw_grid(sint4 tx, sint4 ty)
{
  sint4 x = this->x.to_int();
  sint4 y = this->y.to_int();
  sint4 w = this->w.to_int();
  sint4 h = this->h.to_int();
  
  glDisable(GL_TEXTURE_2D);
  
  // black background
  glColor4f(0, 0, 0, 0.5);
  glBegin(GL_QUADS);
  
  glVertex2f(x,   y);
  glVertex2f(x+w, y);
  glVertex2f(x+w, y+h);
  glVertex2f(x,   y+h);
  
  glEnd();
  
  if (1) {

    real4 grid_opac_x = (real4)(h) / (real4)(ty) / 32.0;
    real4 grid_opac_y = (real4)(w) / (real4)(tx) / 32.0;

    if (grid_opac_x > 1.0) grid_opac_x = 1.0;
    if (grid_opac_y > 1.0) grid_opac_y = 1.0;

    // tile grid
    glBegin(GL_LINES);
    glColor4f(0.8, 0.8, 0.8, grid_opac_y);
    real8 d = (real8)w/(real8)tx;
    FORT(i, tx){
      glVertex2d(x+i*d , y);
      glVertex2d(x+i*d , y+h);
    }
    
    glColor4f(0.8, 0.8, 0.8, grid_opac_x);
    d = (real8)h/(real8)ty;
    FORT(i, ty){
      glVertex2d(x , y+i*d);
      glVertex2d(x+w , y+i*d);
    }
    glEnd();
  }

  // red border
  glColor4f(0.5, 0, 0, 1);
  glBegin(GL_LINE_LOOP);
  
  glVertex2f(x  , y);
  glVertex2f(x+w, y);
  glVertex2f(x+w, y+h);
  glVertex2f(x  , y+h);
  
  glEnd();
}

//===================================================================


