/** @file RandomIsland.C
    @see MapTool.H

    $Id: MapRandomIsland.C,v 1.1 2006/05/29 05:09:17 orts_furtak Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/serverclient/src/MapRandomIsland.C,v $
*/


#include "Global.H"
#include "MapTool.H"
#include "GameConst.H"




using namespace std;

#define MIN(x,y) (x < y ? x : y)
#define MAX(x,y) (x > y ? x : y)
#define PI 3.1415

//
//
//struct Point
//{
//  sint4 x;
//  sint4 y;
//};



// x and y are the centre position of the island
//ramps
bool MapTool::n_ramp(sint4 x, sint4 y, Map < Tile > &map_data, sint4 left_edge, sint4 lower_edge, sint4 right_edge, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  sint4 diff = (level_2 - level_1) / 4;
  for(; y < lower_edge; y++) {
    x = left_edge;
    for(; x < right_edge; x++) {
      if(x + 3 > width - 1 || y > height - 1 || y - 4 < 0 || x < 0)
        continue;
      if(map_data(x, y).get_height(0) == level_2 && map_data(x + 1, y).get_height(0) == level_2 && map_data(x + 2, y).get_height(0) == level_2 && map_data(x + 3, y).get_height(0) == level_2 && map_data(x, y - 4).get_height(0) == level_1 && map_data(x + 1, y - 4).get_height(0) == level_1 && map_data(x + 2, y - 4).get_height(0) == level_1 && map_data(x + 3, y - 4).get_height(0) == level_1) {
        FORS(i, 5) {
          FORS(j, 4) {
            map_data(x + j, y - i).set_type(GROUND);
            map_data(x + j, y - i).set_flat(level_2 - diff * i);
          }
        }
        return true;
      }
    }
  }
  return false;
}

bool MapTool::e_ramp(sint4 x, sint4 y, Map < Tile > &map_data, sint4 left_edge, sint4 lower_edge, sint4 right_edge, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  sint4 diff = (level_2 - level_1) / 4;
  for(; y < lower_edge; y++) {
    x = left_edge;
    for(; x < right_edge; x++) {
      if(x + 4 > width - 1 || y + 3 > height - 1 || y < 0 || x < 0)
        continue;
      if(map_data(x, y).get_height(0) == level_2 && map_data(x, y + 1).get_height(0) == level_2 && map_data(x, y + 2).get_height(0) == level_2 && map_data(x, y + 3).get_height(0) == level_2 && map_data(x + 4, y).get_height(0) == level_1 && map_data(x + 4, y + 1).get_height(0) == level_1 && map_data(x + 4, y + 2).get_height(0) == level_1 && map_data(x + 4, y + 3).get_height(0) == level_1) {
        FORS(i, 4) {
          FORS(j, 5) {
            map_data(x + j, y + i).set_type(GROUND);
            map_data(x + j, y + i).set_flat(level_2 - diff * j);
          }
        }
        return true;
      }
    }
  }
  return false;
}

bool MapTool::w_ramp(sint4 x, sint4 y, Map < Tile > &map_data, sint4 left_edge, sint4 lower_edge, sint4 right_edge, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  sint4 diff = (level_2 - level_1) / 4;
  for(; y < lower_edge; y++) {
    x = left_edge;
    for(; x < right_edge; x++) {
      if(x > width - 1 || y + 3 > height - 1 || y < 0 || x - 4 < 0)
        continue;
      if(map_data(x, y).get_height(0) == level_2 && map_data(x, y + 1).get_height(0) == level_2 && map_data(x, y + 2).get_height(0) == level_2 && map_data(x, y + 3).get_height(0) == level_2 && map_data(x - 4, y).get_height(0) == level_1 && map_data(x - 4, y + 1).get_height(0) == level_1 && map_data(x - 4, y + 2).get_height(0) == level_1 && map_data(x - 4, y + 3).get_height(0) == level_1) {
        FORS(i, 4) {
          FORS(j, 5) {
            map_data(x - j, y + i).set_type(GROUND);
            map_data(x - j, y + i).set_flat(level_2 - diff * j);
          }
        }
        return true;
      }
    }
  }
  return false;
}

bool MapTool::s_ramp(sint4 x, sint4 y, Map < Tile > &map_data, sint4 left_edge, sint4 lower_edge, sint4 right_edge, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  sint4 diff = (level_2 - level_1) / 4;
  for(; y < lower_edge; y++) {
    x = left_edge;
    for(; x < right_edge; x++) {
      if(x + 3 > width - 1 || y + 4 > height - 1 || y < 0 || x < 0)
        continue;
      if(map_data(x, y).get_height(0) == level_2 && map_data(x + 1, y).get_height(0) == level_2 && map_data(x + 2, y).get_height(0) == level_2 && map_data(x + 3, y).get_height(0) == level_2 && map_data(x, y + 4).get_height(0) == level_1 && map_data(x + 1, y + 4).get_height(0) == level_1 && map_data(x + 2, y + 4).get_height(0) == level_1 && map_data(x + 3, y + 4).get_height(0) == level_1) {
        FORS(i, 5) {
          FORS(j, 4) {
            map_data(x + j, y + i).set_type(GROUND);
            map_data(x + j, y + i).set_flat(level_2 - diff * i);
          }
        }
        return true;
      }
    }
  }
  return false;
}

bool MapTool::sw_ramp(sint4 x, sint4 y, Map < Tile > &map_data, sint4 left_edge, sint4 lower_edge, sint4 right_edge, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  sint4 diff = (level_2 - level_1) / 4;
  for(; y < lower_edge; y++) {
    x = left_edge;
    for(; x < right_edge; x++) {
      if(x + 2 > width - 1 || y + 6 > height - 1 || y < 0 || x - 4 < 0)
        continue;
      if(map_data(x, y).get_height(0) == level_2 && map_data(x + 1, y + 1).get_height(0) == level_2 && map_data(x + 2, y + 2).get_height(0) == level_2 && map_data(x - 4, y + 4).get_height(0) == level_1 && map_data(x - 3, y + 5).get_height(0) == level_1 && map_data(x - 2, y + 6).get_height(0) == level_1) {
        FORS(i, 5) {
          FORS(j, 4) {
            map_data(x + j, y + j).set_type(GROUND);
            map_data(x + j, y + j).set_flat(level_2 - diff * i);

          }
          if(i % 2 == 0)
            x--;
          else
            y++;
        }
        return true;
      }
    }
  }
  return false;
}

bool MapTool::nw_ramp(sint4 x, sint4 y, Map < Tile > &map_data, sint4 left_edge, sint4 lower_edge, sint4 right_edge, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  sint4 diff = (level_2 - level_1) / 4;
  for(; y < lower_edge; y++) {
    x = left_edge;
    for(; x < right_edge; x++) {
      if(x + 2 > width - 1 || y > height - 1 || y - 6 < 0 || x - 4 < 0)
        continue;
      if(map_data(x, y).get_height(0) == level_2 && map_data(x + 1, y - 1).get_height(0) == level_2 && map_data(x + 2, y - 2).get_height(0) == level_2 && map_data(x - 4, y - 4).get_height(0) == level_1 && map_data(x - 3, y - 5).get_height(0) == level_1 && map_data(x - 2, y - 6).get_height(0) == level_1) {
        FORS(i, 5) {
          FORS(j, 4) {
            map_data(x + j, y - j).set_type(GROUND);
            map_data(x + j, y - j).set_flat(level_2 - diff * i);

          }
          if(i % 2 == 0)
            x--;
          else
            y--;
        }
        return true;
      }
    }
  }
  return false;
}

bool MapTool::se_ramp(sint4 x, sint4 y, Map < Tile > &map_data, sint4 left_edge, sint4 lower_edge, sint4 right_edge, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  sint4 diff = (level_2 - level_1) / 4;
  for(; y < lower_edge; y++) {
    x = left_edge;
    for(; x < right_edge; x++) {
      if(x + 4 > width - 1 || y + 6 > height - 1 || y - 2 < 0 || x < 0)
        continue;
      if(map_data(x, y).get_height(0) == level_2 && map_data(x + 1, y - 1).get_height(0) == level_2 && map_data(x + 2, y - 2).get_height(0) == level_2 && map_data(x + 4, y).get_height(0) == level_1 && map_data(x + 3, y + 1).get_height(0) == level_1 && map_data(x + 2, y + 2).get_height(0) == level_1) {
        FORS(i, 5) {
          FORS(j, 4) {
            map_data(x + j, y - j).set_type(GROUND);
            map_data(x + j, y - j).set_flat(level_2 - (diff * i));

          }
          if(i % 2 == 0)
            x++;
          else
            y++;
        }
        return true;
      }
    }
  }
  return false;
}

bool MapTool::ne_ramp(sint4 x, sint4 y, Map < Tile > &map_data, sint4 left_edge, sint4 lower_edge, sint4 right_edge, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  sint4 diff = (level_2 - level_1) / 4;
  for(; y < lower_edge; y++) {
    x = left_edge;
    for(; x < right_edge; x++) {
      if(x + 4 > width - 1 || y + 2 > height - 1 || y - 6 < 0 || x < 0)
        continue;
      if(map_data(x, y).get_height(0) == level_2 && map_data(x + 1, y + 1).get_height(0) == level_2 && map_data(x + 2, y + 2).get_height(0) == level_2 && map_data(x + 4, y - 4).get_height(0) == level_1 && map_data(x + 3, y - 5).get_height(0) == level_1 && map_data(x + 2, y - 6).get_height(0) == level_1) {
        FORS(i, 5) {
          FORS(j, 4) {
            map_data(x + j, y + j).set_type(GROUND);
            map_data(x + j, y + j).set_flat(level_2 - diff * i);

          }
          if(i % 2 == 0)
            x++;
          else
            y--;
        }
        return true;
      }
    }
  }
  return false;
}

// always call this one after cliff_tiles, otherwise cliff_tiles won't work right
// dir 0 east else west
bool MapTool::place_ramp(Map < Tile > &map_data, sint4 x, sint4 y, sint4 box_width, sint4 dir, sint4 level_1, sint4 level_2, sint4 width, sint4 height)
{
  cout << dir << endl;
  cout.flush();
  sint4 lower_edge = y + box_width;
  if(lower_edge >= height)
    lower_edge = height - 1;
  sint4 right_edge = x + box_width;
  if(right_edge >= width)
    right_edge = width - 1;
  sint4 left_edge = x;
  if(dir == 0) {                //NORTH
    return n_ramp(x, y, map_data, left_edge, lower_edge, right_edge, level_1, level_2, width, height);
  } else if(dir == 1) {         //NE
    return ne_ramp(x + width / 2, y, map_data, left_edge, lower_edge, right_edge, level_1, level_2, width, height);
  } else if(dir == 2) {         //E
    return e_ramp(x + width / 2, y, map_data, left_edge, lower_edge, right_edge, level_1, level_2, width, height);
  } else if(dir == 3) {         //SE
    return se_ramp(x, y + width / 4, map_data, left_edge, lower_edge, right_edge, level_1, level_2, width, height);
  } else if(dir == 4) {         //S
    return s_ramp(x, y + width / 4, map_data, left_edge, lower_edge, right_edge, level_1, level_2, width, height);
  } else if(dir == 5) {         //SW
    return sw_ramp(x, y + width / 4, map_data, left_edge, lower_edge, right_edge, level_1, level_2, width, height);
  } else if(dir == 6) {         //W
    return w_ramp(x, y, map_data, left_edge, lower_edge, right_edge, level_1, level_2, width, height);
  } else if(dir == 7) {         //NW
    return nw_ramp(x, y, map_data, left_edge, lower_edge, right_edge, level_1, level_2, width, height);
  } else
    return false;

}



//puts cliff tiles around edge of plateaus/islands
void MapTool::cliff_tiles(Map < Tile > &map_data, sint4 width, sint4 height)
{
  // corner heights
  /*
     0 1
     3 2
   */
  sint4 corner_0 = 0;
  sint4 corner_1 = 0;
  sint4 corner_2 = 0;
  sint4 corner_3 = 0;
  sint4 count = 0;
  FORS(x, width)
    FORS(y, height) {
    count = 1;
    Tile & temp = map_data(x, y);
    corner_0 = temp.get_height(0);
    corner_1 = temp.get_height(2);
    corner_2 = temp.get_height(4);
    corner_3 = temp.get_height(6);
    if(!(corner_0 == corner_1 && corner_1 == corner_2 && corner_2 == corner_3)) {
      temp.set_type(CLIFF);
    }
  }
}


//syncs upper_left corner heights of a tile
void MapTool::sync_corner(Map < Tile > &map_data, sint4 width, sint4 height)
{
  /*
     where tiles meet
     3 | 6
     4  |  5
     ______
     1  |  0
     2 | 7
   */

  /*


     2  |  3
     ______
     1  |  0

   */
  // corner heights 
  sint4 corner_0 = 0;
  sint4 corner_1 = 0;
  sint4 corner_2 = 0;
  sint4 corner_3 = 0;
  sint4 height_1;
  sint4 height_2;
  sint4 count = 0;
  for(sint4 x = 1; x < width; x++)
    for(sint4 y = 1; y < height; y++) {
      count = 1;
      Tile & temp = map_data(x, y);
      Tile & left = map_data(x - 1, y);
      Tile & above = map_data(x, y - 1);
      Tile & above_left = map_data(x - 1, y - 1);
      corner_0 = temp.get_height(0);
      corner_1 = left.get_height(1);
      corner_2 = above_left.get_height(3);

      corner_3 = above.get_height(5);
      height_1 = corner_0;
      height_2 = corner_2;
      if(corner_1 == height_1) {
        count++;
      } else
        height_2 = corner_1;
      if(corner_2 == height_1) {
        count++;
      } else
        height_2 = corner_2;
      if(corner_3 == height_1) {
        count++;
      } else
        height_2 = corner_3;
      if(!(corner_0 == corner_1 && corner_1 == corner_2 && corner_2 == corner_3 && corner_3 == corner_0))       //any of the corners don't match up
        if(count > 2) {
          //set corner heights to height_1
          temp.set_topo(height_1, temp.get_height(1), temp.get_height(3), temp.get_height(5), Tile::NO_SPLIT);
          left.set_topo(left.get_height(0), height_1, left.get_height(3), left.get_height(5), Tile::NO_SPLIT);
          above.set_topo(above.get_height(0), above.get_height(1), above.get_height(3), height_1, Tile::NO_SPLIT);
          above_left.set_topo(above_left.get_height(0), above_left.get_height(1), height_1, above_left.get_height(5), Tile::NO_SPLIT);


        } else {                //set corner heights to height_2
          temp.set_topo(height_2, temp.get_height(1), temp.get_height(3), temp.get_height(5), Tile::NO_SPLIT);
          left.set_topo(left.get_height(0), height_2, left.get_height(3), left.get_height(5), Tile::NO_SPLIT);
          above.set_topo(above.get_height(0), above.get_height(1), above.get_height(3), height_2, Tile::NO_SPLIT);
          above_left.set_topo(above_left.get_height(0), above_left.get_height(1), height_2, above_left.get_height(5), Tile::NO_SPLIT);
        }

    }
}

//Returns 1 if p inside polygon
bool MapTool::inside_polygon(vector < Point > &polygon, Point p)
{

  sint4 N = polygon.size();
  if(N <= 2) {
    if(N == 0)
      return false;
    if(p.x == polygon[0].x && p.y == polygon[0].y)
      if(N == 2) {
        if(p.x == polygon[1].x && p.y == polygon[1].y)
          return true;
        else
          return false;
      } else
        return false;
  }
  sint4 counter = 0;
  sint4 i;
  real8 xinters;
  Point p1, p2;

  p1 = polygon[0];
  for(i = 1; i <= N; i++) {
    p2 = polygon[i % N];
    if(p.y > MIN(p1.y, p2.y)) {
      if(p.y <= MAX(p1.y, p2.y)) {
        if(p.x <= MAX(p1.x, p2.x)) {
          if(p1.y != p2.y) {
            xinters = (p.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y) + p1.x;
            if(p1.x == p2.x || p.x <= xinters)
              counter++;
          }
        }
      }
    }
    p1 = p2;
  }

  if(counter % 2 == 0)
    return false;
  else
    return true;
}

//all is sorted in descending order by x coordinates
// max_angle is in degrees
void MapTool::lower_edge(stack < Point > all, stack < Point > &polygon, real8 min_angle)
{
  real8 angle_1 = 0;
  real8 angle_2 = 0;
  real4 x_1 = 0;
  real4 y_1 = 0;
  real4 x_2 = 0;
  real4 y_2 = 0;
  bool dip = false;
  min_angle = min_angle * PI / 180;
  Point next, first, second;
  if(all.size() <= 2) {
    while(!all.empty()) {
      polygon.push(all.top());
      all.pop();
    }
    return;
  }
  polygon.push(all.top());
  all.pop();
  polygon.push(all.top());
  all.pop();
  while(!all.empty()) {
    next = all.top();
    all.pop();
    second = polygon.top();
    polygon.pop();
    first = polygon.top();
    if(min_angle > 0) {
      x_1 = second.x - first.x;
      x_2 = next.x - first.x;
      y_1 = second.y - first.y;
      y_2 = next.y - first.y;
      if(x_1 == 0) {
        if(y_1 < 0) {
          angle_1 = -PI / 2;
        } else {
          angle_1 = PI / 2;
        }
      } else {
        angle_1 = atan(y_1 / x_1);
      }
      if(x_2 == 0) {
        if(y_2 < 0) {
          angle_2 = -PI / 2;
        } else {
          angle_2 = PI / 2;
        }
      } else {
        angle_2 = atan(y_2 / x_2);
      }
      dip = angle_2 >= angle_1 && !polygon.empty();

    } else
      dip = first.y <= second.y && second.y >= next.y && !polygon.empty();
    while(dip) {
      second = first;
      polygon.pop();
      if(polygon.empty())
        break;
      first = polygon.top();
      if(min_angle > 0) {
        x_1 = second.x - first.x;
        x_2 = next.x - first.x;
        y_1 = second.y - first.y;
        y_2 = next.y - first.y;
        if(x_1 == 0) {
          if(y_1 < 0) {
            angle_1 = -PI / 2;
          } else {
            angle_1 = PI / 2;
          }
        } else {
          angle_1 = atan(y_1 / x_1);
        }
        if(x_2 == 0) {
          if(y_2 < 0) {
            angle_2 = -PI / 2;
          } else {
            angle_2 = PI / 2;
          }
        } else {
          angle_2 = atan(y_2 / x_2);
        }
        dip = angle_2 >= angle_1 && !polygon.empty();
      } else
        dip = first.y <= second.y && second.y >= next.y && !polygon.empty();
    }
    polygon.push(second);
    polygon.push(next);
  }
}

//all is sorted in descending order by x coordinates 
void MapTool::upper_edge(stack < Point > all, stack < Point > &polygon, real8 min_angle)
{
  real8 angle_1 = 0;
  real8 angle_2 = 0;
  real4 x_1 = 0;
  real4 y_1 = 0;
  real4 x_2 = 0;
  real4 y_2 = 0;
  bool dip = false;
  min_angle = min_angle * PI / 180;
  Point next, first, second;
  if(all.size() <= 2) {
    while(!all.empty()) {
      polygon.push(all.top());
      all.pop();
    }
    return;
  }
  polygon.push(all.top());
  all.pop();
  polygon.push(all.top());
  all.pop();
  while(!all.empty()) {
    next = all.top();
    all.pop();
    second = polygon.top();
    polygon.pop();
    first = polygon.top();
    if(min_angle > 0) {
      x_1 = second.x - first.x;
      x_2 = next.x - first.x;
      y_1 = second.y - first.y;
      y_2 = next.y - first.y;
      if(x_1 == 0) {
        if(y_1 < 0) {
          angle_1 = -PI / 2;
        } else {
          angle_1 = PI / 2;
        }
      } else {
        angle_1 = atan(y_1 / x_1);
      }
      if(x_2 == 0) {
        if(y_2 < 0) {
          angle_2 = -PI / 2;
        } else {
          angle_2 = PI / 2;
        }
      } else {
        angle_2 = atan(y_2 / x_2);
      }
      dip = angle_2 <= angle_1 && !polygon.empty();

    } else
      dip = first.y >= second.y && second.y <= next.y && !polygon.empty();
    while(dip) {
      second = first;
      polygon.pop();
      if(polygon.empty())
        break;
      first = polygon.top();
      if(min_angle > 0) {
        x_1 = second.x - first.x;
        x_2 = next.x - first.x;
        y_1 = second.y - first.y;
        y_2 = next.y - first.y;
        if(x_1 == 0) {
          if(y_1 < 0) {
            angle_1 = -PI / 2;
          } else {
            angle_1 = PI / 2;
          }
        } else {
          angle_1 = atan(y_1 / x_1);
        }
        if(x_2 == 0) {
          if(y_2 < 0) {
            angle_2 = -PI / 2;
          } else {
            angle_2 = PI / 2;
          }
        } else {
          angle_2 = atan(y_2 / x_2);
        }
        dip = angle_2 <= angle_1 && !polygon.empty();

      } else
        dip = first.y >= second.y && second.y <= next.y && !polygon.empty();
    }
    polygon.push(second);
    polygon.push(next);
  }
}


//diff is the difference in levels
void MapTool::smooth_edge(sint4 x, sint4 y, Map < Tile > &map_data, sint4 diff)
{
  //  bool cliff = opt.cliff;
  //  bool water = opt.water;
  //  sint4 gtiles_x = opt.width, gtiles_y = opt.height;
  uint4 edge;
  /*if(water)
     edge = WATER; //water
     else */
  edge = GROUND;                //ground
  //assert(x > 0 && y > 0 && x < (gtiles_x - 1) && y < (gtiles_y - 1));
  sint4 height = map_data(x, y).get_height(0);
  //fill concavities
  if(map_data(x, y - 1).get_height(4) > height) {
    if(map_data(x + 1, y).get_height(0) > height) {
      map_data(x, y).set_topo(height + diff, height + diff, height + diff, height, Tile::NO_SPLIT);
      map_data(x, y).set_type(edge, GROUND);
      return;
    } else if(map_data(x - 1, y).get_height(2) > height) {
      map_data(x, y).set_topo(height + diff, height + diff, height, height + diff, Tile::NO_SPLIT);
      map_data(x, y).set_type(GROUND, edge);
      return;
    }
  } else if(map_data(x, y + 1).get_height(0) > height) {
    if(map_data(x + 1, y).get_height(0) > height) {
      map_data(x, y).set_topo(height, height + diff, height + diff, height + diff, Tile::NO_SPLIT);
      map_data(x, y).set_type(edge, GROUND);
      return;
    } else if(map_data(x - 1, y).get_height(2) > height) {
      map_data(x, y).set_topo(height + diff, height, height + diff, height + diff, Tile::NO_SPLIT);
      map_data(x, y).set_type(GROUND, edge);
      return;
    }
  }
  //chop tiles that stick out
  if(map_data(x, y).is_flat())
    if(map_data(x, y - 1).get_height(4) < height) {
      if(map_data(x + 1, y).get_height(0) < height) {
        map_data(x, y).set_topo(height, height - diff, height, height, Tile::NO_SPLIT);
        map_data(x, y).set_type(GROUND, edge);
        return;
      } else if(map_data(x - 1, y).get_height(2) < height) {
        map_data(x, y).set_topo(height - diff, height, height, height, Tile::NO_SPLIT);
        map_data(x, y).set_type(edge, GROUND);
        return;
      }
    } else if(map_data(x, y + 1).get_height(0) < height) {
      if(map_data(x + 1, y).get_height(6) < height) {
        map_data(x, y).set_topo(height, height, height - diff, height, Tile::NO_SPLIT);
        map_data(x, y).set_type(GROUND, edge);
        return;
      } else if(map_data(x - 1, y).get_height(4) < height) {
        map_data(x, y).set_topo(height, height, height, height - diff, Tile::NO_SPLIT);
        map_data(x, y).set_type(edge, GROUND);
        return;
      }
    }

}

void MapTool::raise_island(Map < Tile > &map_data, sint4 level_2, sint4 num_islands, sint4 size, sint4 seed)
{
  Random rand;
  rand.srand(seed);
  sint4 tiles_x = opt.width, tiles_y = opt.height;
  sint4 tile_n = tiles_x * tiles_y;
  sint4 r;
  r = rand.rand_uint4();
  //positions of islands
  sint4 *player_x = new sint4[num_islands];
  sint4 *player_y = new sint4[num_islands];
  bool *flags = new bool[tile_n];
  bool *checked = new bool[tile_n];
  if(!player_x || !player_y || !flags || !checked)
    ERR("out of memory");
  memset(player_x, 0, num_islands * sizeof(*player_x));
  memset(player_y, 0, num_islands * sizeof(*player_y));
  memset(flags, false, tile_n * sizeof(*flags));
  memset(checked, 0, tile_n * sizeof(*checked));

  Vector < Point > *edges = new Vector < Point >[num_islands];
  Vector < Point > *islands = new Vector < Point >[num_islands];
  if(!edges || !islands)
    ERR("out of memory");

  sint4 x = 0, y = 0;

  //pick island spots
  FORS(n, num_islands) {
    x = rand.rand_uint4() % tiles_x;
    y = rand.rand_uint4() % tiles_y;
    if(flags[(y * tiles_x) + x] || map_data(x, y).get_height(0) == level_2 || map_data(x, y).get_height(1) == level_2 && map_data(x, y).get_height(3) == level_2 || map_data(x, y).get_height(5) == level_2) {
      n--;
      continue;
    }
    player_x[n] = x;
    player_y[n] = y;
    flags[(y * tiles_x) + x] = true;
  }

  Point t;
  //  bool water = opt.water;
  //  bool cliff = opt.cliff;
  real8 convex = opt.convex;

  sint4 edge = (sint4)(sqrt((real8)(size)));
  sint4 min = edge;
  FORS(k, num_islands) {
    level_2 = rand.rand_uint4() % 13;
    t.x = player_x[k];
    t.y = player_y[k];
    Tile & tile = map_data.get_tile(x, y);
    tile.set_flat(level_2);
    edges[k].push_back(t);
    flags[(y * tiles_x) + x] = true;
    FORS(i, size) {
      seed = rand.rand_uint4();
      if(seed < 0)
        seed = -seed;
      MapTool::add_tile(seed, edges[k], map_data, flags, tiles_x, tiles_y, level_2);
    }
  }
  //convex hull algo
  FORS(k, num_islands) {
    stack < Point > all;
    stack < Point > u_edge;
    stack < Point > l_edge;
    x = player_x[k] + min - 1;
    if(x < 0)
      x = 0;
    if(x > tiles_x - 1)
      x = tiles_x - 1;
    y = player_y[k] + min - 1;
    if(y < 0)
      y = 0;
    if(y > tiles_y - 1)
      y = tiles_y - 1;
    sint4 left_edge = player_x[k] - min;
    if(left_edge < 0)
      left_edge = 0;
    sint4 top = player_y[k] - min;
    if(top < 0)
      top = 0;
    //get island tiles
    while(x > left_edge) {
      y = player_y[k] + min - 1;
      if(y < 0)
        y = 0;
      if(y > tiles_y - 1)
        y = tiles_y - 1;
      while(y > top) {
        if(map_data(x, y).get_height(0) == level_2) {
          t.x = x;
          t.y = y;
          all.push(t);

        }
        y--;
      }
      x--;
    }
    upper_edge(all, u_edge, convex);
    lower_edge(all, l_edge, convex);
    // set points in convex hull to island ground tiles
    x = player_x[k] + min - 1;
    y = player_y[k] + min - 1;
    Vector < Point > poly;
    while(!u_edge.empty()) {
      poly.push_back(u_edge.top());
      u_edge.pop();
    }
    while(!l_edge.empty()) {
      poly.push_back(l_edge.top());
      l_edge.pop();
    }





    while(