#!/bin/bash

#This script will:
# run multiple tests comparing strategies

#  Author: Ken Anderson
#  May 31, 2006

FILENAME=tourney/combat_test.out
TEMP=tourney/temp.out
NICE="nice -10"
PORT=8353
STRAT1="-localstrategy 3"
STRAT2="-globalstrategy 4"

cd ~/Academic/c605/ORTS/orts3/

echo "" > $FILENAME

for ((NUM=0; NUM<500; NUM++))
do
  # Run the Server
  #./bin/orts -marines -bp tournament/game2.bp -nplayers 2 -nobjs -60 -x 32 -y 4 -fplat 0 -nfog -synchro & > $TEMP
  $NICE ./tourney/test_shoot -synchro -f 800 -port $PORT -ids one,two -seed $NUM > $TEMP &
  sleep 1  # wait for server to finish setting up

  # Run the Clients
  $NICE ./bin/combat_test0 -p tournament/ortsg -port $PORT -id one -ngfx $STRAT1 &
  #sleep 1
  $NICE ./bin/combat_test -p tournament/ortsg -port $PORT -id two $STRAT2 

  # Parse Winner Data
  WINNER=`grep -a "wins." $TEMP`
  #grep -a "player 0" $TEMP 
  PLAYER0=`awk '/player 0/ {print $3}' $TEMP`
  PLAYER1=`awk '/player 1/ {print $3}' $TEMP`
  DIFF=$((PLAYER0-PLAYER1))
  
  WINNER="tie"  # if greater than 0
  if [ $DIFF -lt 0 ]  
  then 
    WINNER=0
  elif [ $DIFF -gt 0 ]
  then
    WINNER=1
  fi
#  if[ `echo $DIFF | grep "-" | wc -l` > 0 ] then WINNER=1

  echo "Winner = $WINNER by $DIFF" >> $FILENAME
  echo "Winner = $WINNER by $DIFF"
  #sleep 1
done

cat $FILENAME | sort

