#!/bin/bash
if [ -z "$1" ]
then
  echo ' '
  echo 'syntax:'
  echo '  random_tourney.sh <number of games> <out file>'
  echo ' '
  echo 'example:'
  echo '  random_tourney.sh 10 tourney.log'
  echo ' '
  exit
fi

NUM_GAMES=$1
RESULTS=$2

mv $RESULTS $RESULTS.old
echo "---" 1> $RESULTS
echo "Start Time: " 1>> $RESULTS
date 1>> $RESULTS
echo "---" 1>> $RESULTS
echo "Tourney results:" 1>> $RESULTS
echo "---" 1>> $RESULTS

for i in 1 2 3 4 5 6 7 8 9 10
do
  mv random.$i.wins old.random.$i.wins
done

for i in 1 2 3 4 5 6 7 8 9 10
do

  for j in 1 2 3 4 5 6 7 8 9 10
  do
    player1="-ai random -rmruns 100 -rmdist $i"
    player2="-ai random -rmruns 100 -rmdist $j"
    echo ---------------------------------------------------------------------
    echo Running match:
    echo ... "$player1" 
    echo ... vs.
    echo ... "$player2"
    echo ---------------------------------------------------------------------
    ./run_match.sh $NUM_GAMES "$player1" "$player2" 1>> $RESULTS
    cat ../player1.wins 1>> random.$i.wins
    cat ../player2.wins 1>> random.$j.wins
    mv ../player1.wins ../player1.wins.old
    mv ../player2.wins ../player2.wins.old
  done

done

echo "---" 1>> $RESULTS
for i in 1 2 3 4 5 6 7 8 9 10
do
  wc -l random.$i.wins 1>> $RESULTS
done
echo "---" 1>> $RESULTS

echo "---" 1>> $RESULTS
echo "End Time: " 1>> $RESULTS
echo "---" 1>> $RESULTS
date 1>> $RESULTS
cat $RESULTS
